//
// Generated by SwagGen
// https://github.com/yonaskolb/SwagGen
//

import Foundation
import JSONUtilities

public class Foyer: JSONDecodable, JSONEncodable, PrettyPrintable {

    public var abonnementQuartier: [Quartier]?

    public var dateCreated: Date?

    public var id: String?

    public var identifiantUnique: String?

    public var immeuble: Immeuble?

    public var lastUpdated: Date?

    public var nom: String?

    public var numeroTelephone: String?

    public var utilisateurs: [Utilisateur]?

    public var uuid: [String]?

    public init(abonnementQuartier: [Quartier]? = nil, dateCreated: Date? = nil, id: String? = nil, identifiantUnique: String? = nil, immeuble: Immeuble? = nil, lastUpdated: Date? = nil, nom: String? = nil, numeroTelephone: String? = nil, utilisateurs: [Utilisateur]? = nil, uuid: [String]? = nil) {
        self.abonnementQuartier = abonnementQuartier
        self.dateCreated = dateCreated
        self.id = id
        self.identifiantUnique = identifiantUnique
        self.immeuble = immeuble
        self.lastUpdated = lastUpdated
        self.nom = nom
        self.numeroTelephone = numeroTelephone
        self.utilisateurs = utilisateurs
        self.uuid = uuid
    }

    public required init(jsonDictionary: JSONDictionary) throws {
        abonnementQuartier = jsonDictionary.json(atKeyPath: "abonnementQuartier")
        dateCreated = jsonDictionary.json(atKeyPath: "dateCreated")
        id = jsonDictionary.json(atKeyPath: "id")
        identifiantUnique = jsonDictionary.json(atKeyPath: "identifiantUnique")
        immeuble = jsonDictionary.json(atKeyPath: "immeuble")
        lastUpdated = jsonDictionary.json(atKeyPath: "lastUpdated")
        nom = jsonDictionary.json(atKeyPath: "nom")
        numeroTelephone = jsonDictionary.json(atKeyPath: "numeroTelephone")
        utilisateurs = jsonDictionary.json(atKeyPath: "utilisateurs")
        uuid = jsonDictionary.json(atKeyPath: "uuid")
    }

    public func encode() -> JSONDictionary {
        var dictionary: JSONDictionary = [:]
        if let abonnementQuartier = abonnementQuartier?.encode() {
            dictionary["abonnementQuartier"] = abonnementQuartier
        }
        if let dateCreated = dateCreated?.encode() {
            dictionary["dateCreated"] = dateCreated
        }
        if let id = id {
            dictionary["id"] = id
        }
        if let identifiantUnique = identifiantUnique {
            dictionary["identifiantUnique"] = identifiantUnique
        }
        if let immeuble = immeuble?.encode() {
            dictionary["immeuble"] = immeuble
        }
        if let lastUpdated = lastUpdated?.encode() {
            dictionary["lastUpdated"] = lastUpdated
        }
        if let nom = nom {
            dictionary["nom"] = nom
        }
        if let numeroTelephone = numeroTelephone {
            dictionary["numeroTelephone"] = numeroTelephone
        }
        if let utilisateurs = utilisateurs?.encode() {
            dictionary["utilisateurs"] = utilisateurs
        }
        if let uuid = uuid {
            dictionary["uuid"] = uuid
        }
        return dictionary
    }

    /// pretty prints all properties including nested models
    public var prettyPrinted: String {
        return "\(Swift.type(of: self)):\n\(encode().recursivePrint(indentIndex: 1))"
    }
}
